
module TypeChecker.Universes where

import Syntax.Internal
import Syntax.Values
import Syntax.Sorts
import TypeChecker.Monad
import TypeChecker.Monad.Errors
import TypeChecker.Errors
import TypeChecker.Values.Refresh
import {-# SOURCE #-} TypeChecker.UnfoldConstants -- REMOVE_IF_HADDOCK

{- REMOVE_IF_HADDOCK
-- | Cyclic module dependency with "TypeChecker.UnfoldConstants". The real function
--   is 'TypeChecker.UnfoldConstants.unfoldConstants'.
unfoldConstants :: Value -> Value
REMOVE_IF_HADDOCK -}

instance Ord Universe where
    compare u1 u2   = compare (uValue u1) (uValue u2)

instance Eq SortValue where
    VSUniv u1 == VSUniv u2	= u1 == u2
    VSProp == VSProp		= True
    VSISet == VSISet		= True
    _ == _			= False

instance Ord SortValue where
    VSUniv u1 <= VSUniv u2  = u1 <= u2
    VSISet <= VSUniv _	    = True
    VSISet <= VSISet	    = True
    VSProp <= VSUniv UZero  = False
    VSProp <= VSUniv _	    = True
    VSProp <= VSProp	    = True
    _ <= _		    = False

vsSet  = VSUniv UZero
vsType = uSucc vsSet

uSucc VSISet	    = VSUniv UZero
uSucc VSProp	    = VSUniv (USucc UZero)
uSucc (VSUniv u)    = VSUniv (USucc u)
uSucc (VSStar i)    = VSStar (siSucc i)

--   TODO: Clean this up!
piSort :: SortValue -> SortValue -> SortValue
piSort (VSStar i1) (VSStar i2)	= VSStar $ siMax i1 i2
piSort (VSStar _) s		= s
piSort s (VSStar _)		= s
piSort (VSUniv UZero) VSISet	= VSISet
piSort VSProp VSISet		= VSUniv (USucc UZero)
piSort s VSISet			= s
piSort VSISet s			= s 
-- piSort (VSProp _) VSISet	 = vsType
-- piSort s VSISet			 = s
piSort (VSUniv UZero) VSProp	= VSProp
piSort (VSUniv u1) (VSUniv u2)	= VSUniv (max u1 u2)
piSort VSProp VSProp		= VSProp
piSort VSProp s			= piSort vsType s
piSort s VSProp			= piSort s vsType

sigmaSort :: SortValue -> SortValue -> SortValue
-- sigmaSort (VSUniv UZero) (VSProp i) = VSUniv UZero  -- TODO: not safe!!!
-- sigmaSort (VSUniv u1) (VSUniv u2)   = VSUniv (max u1 u2)
-- sigmaSort (VSProp _) (VSProp i)	    = VSProp i
-- sigmaSort (VSProp _) s		    = sigmaSort (VSUniv (USucc UZero)) s
-- sigmaSort s (VSProp _)		    = sigmaSort s (VSUniv (USucc UZero))
sigmaSort = piSort  -- TODO: this is wrong. Impredicativity doesn't work for sigma

-- | Check if two sorts are equal.

-- type Rules = [(SortValue, SortValue, SortValue)]
-- 
-- matchRule :: Rules -> SortValue -> SortValue -> Maybe SortValue
-- matchRule [] v w = Nothing
-- matchRule ((v',w',u):rs) v w
--     | (v',w') == (v,w)  = Just u
--     | otherwise		= matchRule rs v w
-- 
