-- A looping lambda term using pattern matching on a negative datatype
-- (The default example.)
-- Author:: Andreas Abel
-- Created:: 2004-12-01

-- A negative type with introduction (in)
data Omega : Set where
  lam : (Omega -> Omega) -> Omega

-- "Anti-introduction" (out)
app : Omega -> (Omega -> Omega)
app (lam f) x = f x

-- self-application
selfapp : Omega -> Omega
selfapp = \ x -> app x x

-- and here we we have a looping term
loop : Omega
loop = selfapp (lam selfapp)

-- making the type checker loop::
P : Omega -> Set

bla : P loop -> P loop
-- bla = \x -> x -- loops the type checker, as expected
